VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.ActiveVB.de"
   ClientHeight    =   3705
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6615
   LinkTopic       =   "Form1"
   ScaleHeight     =   3705
   ScaleWidth      =   6615
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ComboBox Combo2 
      Height          =   315
      Left            =   5040
      TabIndex        =   9
      Text            =   "Combo2"
      Top             =   3240
      Width           =   1215
   End
   Begin VB.CheckBox Check2 
      Caption         =   "Check2"
      Height          =   495
      Left            =   480
      TabIndex        =   8
      Top             =   2640
      Width           =   1215
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Check1"
      Height          =   495
      Left            =   360
      TabIndex        =   7
      Top             =   1560
      Width           =   1215
   End
   Begin VB.ComboBox Combo1 
      Height          =   315
      Left            =   1680
      TabIndex        =   6
      Text            =   "Combo1"
      Top             =   960
      Width           =   1215
   End
   Begin VB.TextBox Text1 
      Height          =   495
      Left            =   2760
      TabIndex        =   5
      Text            =   "Text1"
      Top             =   1560
      Width           =   1215
   End
   Begin VB.ListBox List2 
      Height          =   450
      Left            =   3120
      TabIndex        =   4
      Top             =   480
      Width           =   1215
   End
   Begin VB.ListBox List1 
      Height          =   450
      Left            =   720
      TabIndex        =   3
      Top             =   240
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   495
      Left            =   1800
      TabIndex        =   2
      Top             =   1920
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Label2"
      Height          =   495
      Left            =   3600
      TabIndex        =   1
      Top             =   1560
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   495
      Left            =   4920
      TabIndex        =   0
      Top             =   720
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!


'-------------------------------------------------------------
' Dieses Formular zeigt, wie die Assembler-Routine arrSRT
' eingesetzt wird, um mittels ASM ziemlich schnell Arrays zu
' sortieren. Der ASM-Quellcode kann in der Datei arrSRT.ASM
' eingesehen und ggf. den Bedrfnissen angepat werden. Der
' Originalcode stammt von Daniel Aue und ist im ActiveVB-
' Upload verfgbar. nderungen sind im Header der Datei
' arrSRT gelistet.
'
' Auf den ActiveVB-Seiten knnen eine Reihe Sortierroutinen
' eingesehen werden, die reinen VB-Code nutzen. Deshalb wurde
' hier auf eine "bersetzung" der ASM-Routine verzichtet.
'
'-------------------------------------------------------------
' Ein Formular mit: Label1, List1, Check1, Combo1, Text1,
'                   Label2, List2, Check2, Combo2, Command1
'                   Label3
'-------------------------------------------------------------

Option Explicit

Private Const C2T As Long = 567 ' cm to twips

Private arrB() As Byte      ' arrays verschiedenen
Private arrI() As Integer   ' Typs fr die
Private arrL() As Long      ' Sortiertests
Private arrX() As Double
Private arrD() As Date
Private arrC() As Currency
Private arrS() As String
Private arrR() As Variant   ' Referenz-Array

Private cur(1) As Currency  ' Zeitmessung
Private ini    As Boolean   ' Initialisierungsflag

' API-Kopierfunktion
Private Declare Sub memCPY _
    Lib "kernel32" Alias "RtlMoveMemory" _
   (ByRef hpvDest As Any, _
    ByRef hpvSource As Any, _
    ByVal cbCopy As Long)

' Formular mit Vorgaben fllen
Private Sub Form_Load()
    Me.Caption = "Arrays sortieren mit ASM"
    Label1.Caption = "Datentyp"
    Label2.Caption = "Elemente"
    Text1.Text = "1000"
    Check1.Caption = "absteigend"
    Check2.Caption = "vorzeichenlos"
    Command1.Caption = "Sort"
    List1.Font = "Courier new"
    List2.Font = "Courier new"
    
    With Combo1
        .AddItem "Byte"
        .AddItem "Integer"
        .AddItem "Long"
        .AddItem "Double"
        .AddItem "Date"
        .AddItem "Currency"
        .AddItem "String"
        
        .ListIndex = 2
    End With
    
    With Combo2
        .AddItem "Standard"
        .AddItem "Lexikon"
        .AddItem "ASCII"
        
        .ListIndex = 0
    End With

    ini = True
End Sub

' absteigend
Private Sub Check1_Click()
    Command1_Click
End Sub

' vorzeichenlos
Private Sub Check2_Click()
    Command1_Click
End Sub

' Auswahl der zu sortierenden Datentypen
Private Sub Combo1_Click()
    Dim N1 As Long
    
    ' Anzahl beschrnken
    N1 = Val(Text1)
    If N1 < 1 Or N1 > 2000000 Then
        MsgBox "Ungltige Elementzahl"
        
    Else
        
        ' Ein entsprechendes Array vorbereiten
        Select Case Combo1.ListIndex
        Case 0: MyRedim arrB, N1, 0, 255
        Case 1: MyRedim arrI, N1, -32768, 65535
        Case 2: MyRedim arrL, N1, -2147483648#, 4294967295#
        Case 3: MyRedim arrX, N1, -2147483648#, 4294967295#
        Case 4: MyRedim arrD, N1, #1/1/1980#, 372183
        Case 5: MyRedim arrC, N1, -2147483648#, 429496729500000#
        Case 6: MyRedim arrS, N1, 0, 0
        End Select
    End If
End Sub

' Sortiermethode auswhlen
Private Sub Combo2_Click()
    Command1_Click
End Sub

' Sortieren
Private Sub Command1_Click()
    Dim flg As Long
    
    ' Werte eingegeben?
    If ini Then
        
        'Flags erstellen
        flg = srtReferenceArr Or _
              IIf(Check1.Value, srtDescending, 0) Or _
              IIf(Check2.Value, srtUnsigned, 0) Or _
              (Combo2.ListIndex * 8)
        
        ' Sortierfunktion aufrufen
        Select Case Combo1.ListIndex
        Case 0: MySort arrB, flg, VarPtr(arrB(0)), 1
        Case 1: MySort arrI, flg, VarPtr(arrI(0)), 2
        Case 2: MySort arrL, flg, VarPtr(arrL(0)), 4
        Case 3: MySort arrX, flg, VarPtr(arrX(0)), 8
        Case 4: MySort arrD, flg, VarPtr(arrD(0)), 8
        Case 5: MySort arrC, flg, VarPtr(arrC(0)), 8
        Case 6: MySort arrS, flg, VarPtr(arrS(0)), 4
        End Select
    End If
End Sub

' Formulargre ndert sich
Private Sub Form_Resize()
    Dim X1      As Double   ' X-Position
    Dim Y1      As Double   ' Y-Position
    Dim W1      As Double   ' Breite
    Dim D1      As Double   ' Abstand
    Dim FW      As Double   ' Breiten-Faktor
    Dim I1      As Long     ' Zhler
    Dim A1()    As String   ' Steuerelement-Namen
    
    On Error Resume Next
    
    ' Gren speichern
    I1 = Me.Width - Me.ScaleWidth + 11.6 * C2T
    If Me.Width < I1 Then Me.Width = I1
    FW = Me.Width / I1
    
    I1 = Me.Height - Me.ScaleHeight _
       + (3 * 0.75 + 0.5 + 4.25) * C2T
    If Me.Height < I1 Then Me.Height = I1
    
    ' Steuerelemente und Angaben zerlegen
    A1 = Split("1.5;0;Label1;Label2;;" & _
               "2.5;.8;Combo1;Text1;;" & _
               "2.5;.8;Combo2;Check1;Check2;" & _
               "3;0;Command1;Label3;", ";")
    
    ' Position oben Links festlegen
    X1 = 0.25 * C2T
    Y1 = 2.5 * C2T
    
    ' Fr jedes Element
    For I1 = 0 To UBound(A1)
        
        ' Nach jedem 5. Element neue Position speichern
        If (I1 Mod 5) = 0 Then
            X1 = X1 + W1 + D1
            Y1 = Y1 - 2.25 * C2T
            W1 = Val(A1(I1)) * C2T * FW
            D1 = Val(A1(I1 + 1)) * C2T * FW
            I1 = I1 + 2
        End If
        
        ' Sollte noch ein Control existieren,
        ' dieses unter dem letzen ausrichten
        If Len(A1(I1)) > 0 Then
            With Me.Controls(A1(I1))
                .Top = Y1
                .Left = X1
                .Width = W1
                .Height = 0.5 * C2T
            End With
        End If
        
        ' Jetzt eine Zeile tiefer gehen
        Y1 = Y1 + 0.75 * C2T
    Next
    
    ' 1. Liste ausrichten
    With List1
        .Top = Check2.Top + 1 * C2T
        .Left = 0.25 * C2T
        .Width = (ScaleWidth - C2T) / 2
        .Height = (ScaleHeight - .Top)
    End With
    
    ' 2. Liste ausrichten
    With List2
        .Top = List1.Top
        .Left = 0.75 * C2T + List1.Width
        .Width = List1.Width
        .Height = List1.Height
    End With
End Sub

' Neue Anzahl Elemente -> Liste Fllen
Private Sub Text1_Change()
    If Val(Text1.Text) Then Combo1_Click
End Sub

' Ein Array ausgeben
Function Display(arr, md As Boolean)
    Dim C1 As ListBox
    Dim I1 As Long
    Dim J1 As Long
    Dim J2 As Long
    Dim J3 As Long
    Dim N1 As Long
    
    ' Obergrenze
    N1 = UBound(arr)
    
    ' Obergrenze festlegen
    ' Wenn mehr als 50 Elemente vorhanden sind,
    ' Nur die ersten 25 nehmen und die Anzahl
    ' anderswo speichern
    J1 = N1
    If J1 > 49 Then J1 = 24: J2 = N1
    
    J3 = 0
    
    ' Bentigte Listen leeren
    If md Then Set C1 = List2 Else Set C1 = List1
    C1.Clear: If Not md Then List2.Clear
    
    Do
        ' Alle/25 Werte ausgeben
        For I1 = J3 To J1
            C1.AddItem Format(arrR(I1), "(000000) ") & arr(I1)
        Next
        
        ' Sollte es mehr als 25 Werte geben -> Seperator einfgen
        If J2 Then C1.AddItem "..."
        
        J3 = N1 - 24
        J1 = J2
        J2 = 0
    Loop Until J1 = 0
End Function

' Array redimensionieren und mit Werten Fllen
Function MyRedim(arr As Variant, cnt As Variant, _
    min As Variant, max As Variant)
    
    Dim T1 As String
    Dim T2 As String
    Dim I1 As Long
    Dim J1 As Long
    
    ' Hier werden Arrays mit dummy-Werten versehen
    ReDim arr(cnt - 1)
    ReDim arrR(cnt - 1)
    
    Randomize Timer
    
    ' Soll ein String zurckgegeben werden?
    If (VarType(arr) And 15) = vbString Then
        
        ' Zeichenvorrat festlegen
        T1 = "0123456789" _
           & "ABCDEFGHIJKLMNOPQRSTUVWXYZ" _
           & "abcdefghijklmnopqrstuvwxyz"
        
        ' Jedes Element durchlaufen
        For I1 = 0 To cnt - 1
            arrR(I1) = I1
            T2 = Space(Rnd() * 20)
            
            ' Jedes Element mit 20 Zufallszahlen fllen
            For J1 = 1 To Len(T2)
                Mid$(T2, J1, 1) = Mid$(T1, 1 + Fix(Rnd() * 62))
            Next J1
            arr(I1) = T2
        Next I1
            
        ' Kein String
    Else
        
        ' Jedes Element mit Zahlen im vorgegebenen Rahmen fllen
        For I1 = 0 To cnt - 1
            arrR(I1) = I1
            arr(I1) = min + Fix(Rnd() * max)
        Next
    End If
    
    ' Neues Array anzeigen
    Display arr, False
End Function

Function MySort(arr, flg As Long, ptr As Long, cnt As Long)
    Dim N1      As Long
    Dim bar()   As Byte
    
    ' Um die Anzeige bei mehrfacher Sortierung gleich zu
    ' behalten, den ursprnglichen Arrayinhalt sichern
    If UBound(arr) Then
        N1 = cnt * (UBound(arr) + 1)
        ReDim bar(N1 - 1)
        memCPY bar(0), ByVal ptr, N1
    End If
    
    ' hier wird die Sortierroutine aufgerufen
    arrSRT arr, arrR, flg
    Display arr, True
    
    ' gesicherte Arraywerte zurckschreiben
    If N1 Then memCPY ByVal ptr, bar(0), N1
End Function
